###############################################################################
# AdminEdit.pl                                                                #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3.1                                      #
# Released:       December 2001; Updated April 18, 2003                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$admineditplver = "1 Gold - SP 1.3.1";

sub EditNews {
	&is_admin;
	my($line);
	$yymain .= qq~
<form action="$cgi;action=editnews2" method="POST">
<table border="0" width="70%" cellspacing="1" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'7'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><BR><font size="1">$txt{'670'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><BR>
    <font size=2>
    <textarea cols=70 rows=8 name="news">
~;
	fopen(FILE, "$vardir/news.txt");
	while($line = <FILE>) { chomp $line; $yymain .= qq~$line~; }
	fclose(FILE);
	$yymain .= qq~
</textarea><br><input type="submit" value="$txt{'10'}"></font><BR></td>
  </tr>
</table>
</form>
~;
	$yytitle = "$txt{'7'}";
	&template;
	exit;
}

sub EditNews2 {
	&is_admin;
	fopen(FILE, ">$vardir/news.txt", 1);
	chomp $FORM{'news'};
	print FILE "$FORM{'news'}";
	fclose(FILE);
	$yySetLocation = qq~$cgi\;action=admin~;
	&redirectexit;
}

sub EditMemberGroups {
	&is_admin;
	my(@lines, $mgroups, $i);
	fopen(FILE, "$vardir/membergroups.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 7; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$mgroups .= "$lines[$i]\n";
	}
	$yymain .= qq~
<table border="0" width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/guest.gif" alt="" border="0">
    <font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'8'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <form action="$cgi;action=modmemgr2" method="POST">
    <table border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="right"><font size=2><b>$txt{'11'}:</b></font></td>
        <td><input type=text name="admin" size=30 value="$lines[0]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'12'}:</b></font></td>
        <td><input type=text name="moderator" size=30 value="$lines[1]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'569'}:</b></font></td>
        <td><input type=text name="newbie" size=30 value="$lines[2]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'13'}:</b></font></td>
        <td><input type=text name="junior" size=30 value="$lines[3]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'14'}:</b></font></td>
        <td><input type=text name="full" size=30 value="$lines[4]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'15'}:</b></font></td>
        <td><input type=text name="senior" size=30 value="$lines[5]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'570'}:</b></font></td>
        <td><input type=text name="god" size=30 value="$lines[6]"></td>
      </tr><tr>
        <td align="right"><font size=2><B>$txt{'16'}:</b></font></td>
        <td><textarea name="additional" cols=30 rows=5>$mgroups</textarea><BR>
        <center><input type="submit" value="$txt{'10'}"></center></td>
      </tr>
    </table>
    </form>
    </font></td>
  </tr>
</table>
~;
	$yytitle = $txt{'8'};
	&template;
	exit;
}

sub EditMemberGroups2 {
	&is_admin;
	my $additional = $FORM{'additional'};
	while( $groups = each(%FORM) ) {
		$FORM{$groups} =~ tr/\n//d;
		$FORM{$groups} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/membergroups.txt", 1);
	print FILE "$FORM{'admin'}\n";
	print FILE "$FORM{'moderator'}\n";
	print FILE "$FORM{'newbie'}\n";
	print FILE "$FORM{'junior'}\n";
	print FILE "$FORM{'full'}\n";
	print FILE "$FORM{'senior'}\n";
	print FILE "$FORM{'god'}\n";
	print FILE "$additional";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

sub SetCensor {
	&is_admin;
	my( @censored, $i );
	fopen(FILE, "$vardir/censor.txt");
	@censored = <FILE>;
	fclose(FILE);
	foreach $i (@censored) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	$yymain .= qq~
<table border="0" width="300" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/ban.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'135'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size=2>
    <form action="$cgi;action=setcensor2" method="POST">
    $txt{'136'}<br>
    <textarea cols=55 rows=15 name="censored">
~;
	foreach $i (@censored) {
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		$yymain .= "$i\n";
	}
	$yymain .= qq~
</textarea><br><BR>
    <input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'135'}";
	&template;
	exit;
}

sub SetCensor2 {
	&is_admin;
	$FORM{'censored'} =~ tr/\r//d;
	$FORM{'censored'} =~ s~\A[\s\n]+~~;
	$FORM{'censored'} =~ s~[\s\n]+\Z~~;
	$FORM{'censored'} =~ s~\n\s*\n~\n~g;
	my @lines = split( /\n/, $FORM{'censored'} );
	fopen(FILE, ">$vardir/censor.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

sub SetReserve {
	my( @reserved, @reservecfg, $i );
	&is_admin;
	fopen(FILE, "$vardir/reserve.txt");
	@reserved = <FILE>;
	fclose(FILE);
	fopen(FILE, "$vardir/reservecfg.txt");
	@reservecfg = <FILE>;
	fclose(FILE);
	for(my $i = 0; $i < @reservecfg; $i++) { chomp $reservecfg[$i]; }

	$yymain .= qq~
<table border=0 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4" width="580">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
    <img src="$imagesdir/profile.gif" alt="" border="0">
    <font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'341'}</b></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg">
    <font size="1"><BR>$txt{'699'}<BR><BR></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size=2>
    <form action="$cgi;action=setreserve2" method="POST">
    <center>$txt{'342'}<br>
    <textarea cols=30 rows=6 name="reserved">
~;
	foreach $i (@reserved) {
		chomp $i;
		$i =~ s~\t~~g;
		if( $i !~ m~\A[\S|\s]*[\n\r]*\Z~) { next; }
		$yymain .= "$i\n";
	}
	$yymain .= qq~</textarea></center><br>
	<font size=2><input type=checkbox name="matchword" value="checked" $reservecfg[0]></font>
	<font size=2>$txt{'726'}</font><br>
	<font size=2><input type=checkbox name="matchcase" value="checked" $reservecfg[1]></font>
	<font size=2>$txt{'727'}</font><br>
	<font size=2><input type=checkbox name="matchuser" value="checked" $reservecfg[2]></font>
	<font size=2>$txt{'728'}</font><br>
	<font size=2><input type=checkbox name="matchname" value="checked" $reservecfg[3]></font>
	<font size=2>$txt{'729'}</font><br>
	<center><input type=submit value="$txt{'10'}"></center></form></font></td>
</tr>
</table>
~;
	$yytitle = "$txt{'341'}";
	&template;
	exit;
}

sub SetReserve2 {
	&is_admin;
	$FORM{'reserved'} =~ tr/\r//d;
	$FORM{'reserved'} =~ s~\A[\s\n]+~~;
	$FORM{'reserved'} =~ s~[\s\n]+\Z~~;
	$FORM{'reserved'} =~ s~\n\s*\n~\n~g;
	fopen(FILE, ">$vardir/reserve.txt", 1);
	my $matchword = $FORM{'matchword'} eq 'checked' ? 'checked' : '';
	my $matchcase = $FORM{'matchcase'} eq 'checked' ? 'checked' : '';
	my $matchuser = $FORM{'matchuser'} eq 'checked' ? 'checked' : '';
	my $matchname = $FORM{'matchname'} eq 'checked' ? 'checked' : '';
	print FILE $FORM{'reserved'};
	fclose(FILE);
	fopen(FILE, "+>$vardir/reservecfg.txt");
	print FILE "$matchword\n";
	print FILE "$matchcase\n";
	print FILE "$matchuser\n";
	print FILE "$matchname\n";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

sub ModifyTemplate {
	&is_admin;
	my( $fulltemplate, $line );
	fopen(FILE, "$boarddir/template.html");
	while( $line = <FILE> ) {
		$line =~ s~[\r\n]~~g;
		&FromHTML;
		$fulltemplate .= qq~$line\n~;
	}
	fclose(FILE);
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'216'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size="1">$txt{'682'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <form action="$cgi;action=modtemp2" method="POST"><BR>
    <textarea rows=30 cols=95 wrap=virtual name="template" style="width:98%">$fulltemplate</textarea>
    <br><BR><input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'216'}";
	&template;
	exit;
}

sub ModifyTemplate2 {
	&is_admin;
	$FORM{'template'} =~ tr/\r//d;
	$FORM{'template'} =~ s~\A\n~~;
	$FORM{'template'} =~ s~\n\Z~~;
	fopen(FILE, ">$boarddir/template.html");
	print FILE $FORM{'template'};
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

sub ModifyAgreement {
	&is_admin;
	my( $fullagreement, $line );
	fopen(FILE, "$vardir/agreement.txt");
	while( $line = <FILE> ) {
		$line =~ tr/[\r\n]//d;
		&FromHTML($line);
		$fullagreement .= qq~$line\n~;
	}
	fclose(FILE);
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'764'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size="1">$txt{'765'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <form action="$cgi;action=modagreement2" method="POST"><BR>
    <textarea rows=30 cols=95 wrap=virtual name="agreement" style="width:98%">$fullagreement</textarea>
    <br><BR><input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'764'}";
	&template;
	exit;
}

sub ModifyAgreement2 {
	&is_admin;
	$FORM{'agreement'} =~ tr/\r//d;
	$FORM{'agreement'} =~ s~\A\n~~;
	$FORM{'agreement'} =~ s~\n\Z~~;
	fopen(FILE, ">$vardir/agreement.txt");
	print FILE $FORM{'agreement'};
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

## /START section added in File Attachments v2.4 to auto-config paths needed for mod
sub AttachDir {
	&is_admin;
	my $findme = 'attachments'; # Set this equal to the name of your attachments directory.
	if((-d $_) && ($_ eq "$findme")) {
		$upload_dir = "$File::Find::dir/$_";
	}
}
## /END File Attachment auto-config paths section

sub ModifySettings {
	&is_admin;
	if($imspam eq "off") {$imspam = "";}
	my($mainchecked, $guestaccchecked, $forcechecked, $blankchecked, $agreechecked, $mailpasschecked, $newpasschecked, $welchecked);
	my($menuchecked, $ubbcchecked, $aluchecked, $cpchecked, $pbchecked, $insertchecked, $newschecked, $gpchecked, $notifchecked);
	my ($uapchecked, $upchecked);
	my($ahmchecked, $slmchecked, $srbarchecked, $smbarchecked, $smreadchecked, $smodchecked, $supicchecked, $sutextchecked, $sgichecked);
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
	my($sviewmailcolm, $sviewicqcolm, $sviewwwwcolm, $sviewimcolm, $sviewyimcolm, $sviewaimcolm, $sviewmsncolm, $sviewregcolm, $bmd1, $bmd2, $defml1, $defml2, $defml3, $defml4);
	my($sviewnumbcolm, $sviewipcolm, $sguest_allow, $sviewnumb, $smailpic, $smailtxt, $swwwpic, $swwwtxt, $simpic, $simtxt, $sicqpic, $sicqtxt, $syimpic, $syimtxt, $saimpic, $saimtxt);
	my($sviewgendcolm, $sgendpic, $sgendtxt, $senablebuddy, $mxbar1, $mxbar2, $mxbar3);
	my($checkextcheck, $extlist, $extitem, $amdisplaypicscheck, $allowattachcheck, $allowguestattachcheck, $st0, $st1, $st2, $tmpax0, $tmpax1);

## /START section added in File Attachments v2.4 to auto-config paths needed for mod
	if ((!$upload_dir || !$http_dir) && $ENV{'DOCUMENT_ROOT'} && $INFO{'famod'} ne "autoconfig") {
		$attachment_status = qq~
		  </tr><tr>
		    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><a href="$cgi;action=modsettings;famod=autoconfig"><font size="2">Click to attempt to auto-configure mod</font></a></td>
		  ~;
	}
		
	if(!$upload_dir && $ENV{'DOCUMENT_ROOT'} && $INFO{'famod'} eq "autoconfig") {
		my $toplevel = "$ENV{'DOCUMENT_ROOT'}";
		if($http_dir) {
			my $upload_dir_temp = $http_dir;
			$upload_dir_temp =~ s~http://[\w|\.]+/?(\S*)~$1~is;
			$upload_dir = "$toplevel/$upload_dir_temp";
			$attachment_status = qq~
				  </tr><tr>
				    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory set to: $upload_dir.\\nPlease save your settings.");</script></font></td>
				  ~;			
		} else {
			eval { use File::Find; };
			unless($@) {
				&find(\&AttachDir, $toplevel);
				if($upload_dir && !$http_dir) {
					my $http_dir_temp = $boardurl;
					$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
					my $http_dir_temp2 = $upload_dir;
					$http_dir_temp2 =~ s~$toplevel/?(\S*)~$1~is;
					$http_dir = "$http_dir_temp/$http_dir_temp2";
					$attachment_status = qq~
						  </tr><tr>
						    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory set to: $upload_dir.\\nAttachments URL set to: $http_dir.\\nPlease save your settings.");</script></font></td>
						  ~;			
				}
				if(!$upload_dir && (-e "$toplevel/yabbattach")) {
					$upload_dir = "$toplevel/yabbattach";
					my $http_dir_temp = $boardurl;
					$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
					$http_dir = "$http_dir_temp/yabbattach";
					$attachment_status = qq~
						  </tr><tr>
						    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory set to: $upload_dir.\\nAttachments URL found: $http_dir.\\nPlease save your settings.");</script></font></td>
						  ~;	
				} elsif(!$upload_dir && (!-e "$toplevel/yabbattach")) { 
					mkdir("$toplevel/yabbattach", 0766) || &fatal_error("Could not create $toplevel/yabbattach for attachments directory.");
					my $http_dir_temp = $boardurl;
					$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
					$http_dir = "$http_dir_temp/yabbattach";		
					$upload_dir = "$toplevel/yabbattach";
					$attachment_status = qq~
						  </tr><tr>
						    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory created and set to: $upload_dir.\\nAttachments URL set to: $http_dir.\\nPlease save your settings.");</script></font></td>
						  ~;
				}
			}
		}
	}
	if(!$http_dir && $ENV{'DOCUMENT_ROOT'} && $upload_dir && $INFO{'famod'} eq "autoconfig") {
		my $toplevel = "$ENV{'DOCUMENT_ROOT'}";
		my $http_dir_temp = $boardurl;
		$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
		my $http_dir_temp2 = $upload_dir;
		$http_dir_temp2 =~ s~$toplevel/?(\.*)~$1~is;
		$http_dir = "$http_dir_temp/$http_dir_temp2";
		$attachment_status = qq~
			  </tr><tr>
			    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments URL set to: $http_dir.\\nPlease save your settings.");</script></font></td>
			  ~;
	}

## /END File Attachment auto-config paths section

	# figure out what to print
	$extlist = join(" ", @ext);
	$extlist =~ s~\s+$~~;
	$extlist =~ s~^\s+~~;
	if ($checkext == 1) { $checkextcheck = ' checked'; }
	if ($amdisplaypics == 1) { $amdisplaypicscheck = ' checked'; }
	if ($allowattach == 1) { $allowattachcheck = ' checked'; }
	if ($allowguestattach == 1) { $allowguestattachcheck = ' checked'; }
	if ($maintenance) { $mainchecked = ' checked'; }
	if ($guestaccess == 0) { $guestaccchecked = ' checked'; }
	if($RegAgree) { $agreechecked = " checked"; }
	if($emailpassword) { $mailpasschecked = " checked"; }
	if($emailnewpass) { $newpasschecked = " checked"; }
	if($emailwelcome) { $welchecked = " checked"; }
	if ($MenuType) { $menuchecked = ' checked'; }
	if ($enable_ubbc) { $ubbcchecked = ' checked'; }
	if ($show_smilie_block) { $showblockchecked = " checked"; }
	if ($autolinkurls) { $aluchecked = ' checked'; }
	if ($curposlinks) { $cpchecked = ' checked'; }
	if ($profilebutton) { $pbchecked = ' checked'; }
	if ($enable_news) { $newschecked = "checked" }
	if ($enable_guestposting) { $gpchecked = "checked" }
	if ($enable_notification) { $notifchecked = "checked" }
	if ($allow_hide_email) { $ahmchecked = "checked" }
	if ($showlatestmember) { $slmchecked = "checked" }
	if ($Show_RecentBar) { $srbarchecked = "checked" }
	if ($showmarkread) { $smreadchecked = "checked" }
	if ($showmodify) { $smodchecked = "checked" }
	if ($ShowBDescrip) { $bdescripchecked = "checked" }
	if ($showuserpic) { $supicchecked = "checked" }
	if ($showusertext) { $sutextchecked = "checked" }
	if ($enable_mailsounds) {$senablemailsounds = 'checked' }
	if ($enable_mailpopup) {$senablemailpopup = 'checked' }
	if ($enable_imlimit) {$senableimlimit = 'checked' }
	if ($send_welcomeim) {$send_welcomeimchecked = 'checked' }
	if ($enable_buddies) {$enable_buddieschecked = 'checked' }
	if ($popup_on) {$popup_onchecked = 'checked' }
	if ($system_im) {$system_imchecked = 'checked' }
	if ($showgenderimage) { $sgichecked = "checked" }
	if ($shownewsfader) { $snfchecked = "checked" }
	if ($showyabbcbutt) { $syabbcchecked = "checked" }
	$maxpq ||= 60;
	$maxpo ||= 50;
	$maxpc ||= 0;
	$numpolloptions ||= 8;
	if ($useraddpoll) { $uapchecked = " checked" }
	if ($ubbcpolls) { $upchecked = " checked" }
	if ($allowpics) { $allowpicschecked = "checked" }
	if ($use_flock == 0) { $fls1 = " selected" } elsif ($use_flock == 1) { $fls2 = " selected" } elsif ($use_flock == 2) { $fls3 = " selected" }
	$utfchecked = $usetempfile ? ' checked' : '';
	$truncchecked = $faketruncation ? ' checked' : '';
	if ($mailtype == 0) { $mts1 = ' selected'; } elsif ($mailtype == 1) { $mts2 = ' selected'; } elsif( $mailtype == 2 ) { $mts3 = ' selected'; }
	if ($timeselected == 6) { $tsl6 = " selected" } elsif ($timeselected == 5) { $tsl5 = " selected" } elsif ($timeselected == 4) { $tsl4 = " selected" } elsif ($timeselected == 3) { $tsl3 = " selected" } elsif ($timeselected == 2) { $tsl2 = " selected" } else { $tsl1 = " selected" }
	if ($barmaxdepend == 0) { $bmd1 = 'checked'; } else { $bmd2 = 'checked'; }
	if ($defaultml == 0) { $defml1 = ' selected'; } elsif ($defaultml == 1) { $defml2 = ' selected'; } elsif( $defaultml == 2 ) { $defml3 = ' selected'; } elsif( $defaultml == 3 ) { $defml4 = ' selected'; }
	if ($maxbar == $membtxt{'02b'}) { $mxbar1 = ' selected'; } elsif ($maxbar == $membtxt{'02c'}) { $mxbar2 = ' selected'; } elsif( $maxbar == $membtxt{'02d'}) { $mxbar3 = ' selected'; } else { $mxbar1 = ' selected'; }
	if ($view_mailcolm) { $sviewmailcolm = 'checked' }
	if ($view_icqcolm) { $sviewicqcolm = 'checked' }
	if ($view_wwwcolm) { $sviewwwwcolm = 'checked' }
	if ($view_imcolm) { $sviewimcolm = 'checked' }
	if ($view_yimcolm) { $sviewyimcolm = 'checked' }
	if ($view_aimcolm) { $sviewaimcolm = 'checked' }
	if ($view_msncolm) { $sviewmsncolm = 'checked' }
	if ($view_regdate) { $sviewregcolm = 'checked' }
	if ($view_numbcolm) { $sviewnumbcolm = 'checked' }
	if ($enable_buddylist) { $senablebuddy = 'checked' }
	if ($view_numb) { $sviewnumb = 'checked' }
	if ($view_ipcolm) { $sviewipcolm = 'checked' }
	if ($view_gendcolm) { $sviewgendcolm = 'checked' }
	if ($guest_allow) { $sguest_allow = 'checked' }
	if ($gendcol eq "pic") { $sgendpic = 'checked' } else { $sgendtxt = 'checked' }
	if ($mailcol eq "pic") { $smailpic = 'checked' } else { $smailtxt = 'checked' }
	if ($wwwcol eq "pic") { $swwwpic = 'checked' } else { $swwwtxt = 'checked' }
	if ($imcol eq "pic") { $simpic = 'checked' } else { $simtxt = 'checked' }
	if ($icqcol eq "pic") { $sicqpic = 'checked' } else { $sicqtxt = 'checked' }
	if ($yimcol eq "pic") { $syimpic = 'checked' } else { $syimtxt = 'checked' }
	if ($aimcol eq "pic") { $saimpic = 'checked' } else { $saimtxt = 'checked' }
	$imtext =~ s/\&\&/\n/g;
	$imtext =~ s/\&lt;/</g;
	$imtext =~ s/\&gt;/>/g;
	$imsubject =~ s/\&\&/\n/g;
	$imsubject =~ s/\&lt;/</g;
	$imsubject =~ s/\&gt;/>/g;
	if ($servertype == 0) { $st0 = " selected"; } elsif ($servertype == 1) { $st1 = " selected"; } elsif ($servertype == 2) { $st2 = " selected"; }
	if ($tempaccess == 0) { $tmpax0 = " selected"; } elsif ($tempaccess == 1) { $tmpax1 = " selected"; }

	$yymain .= qq~
<form action="$cgi;action=modsettings2" name="modsettings" method="POST">
<table width="90%" border="0" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
  <td>
  <table border="0" cellspacing="0" cellpadding="4" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan=2>
    <img src="$imagesdir/preferences.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'222'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=2><BR><font size="1">$txt{'347'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'350'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="mbname" size="35" value="$mbname"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'351'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="boardurl" size="45" value="$boardurl"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'349'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="language">
~;
opendir(DIR, "$boarddir") || die "$txt{'230'} ($boarddir) :: $!";
@contents = readdir(DIR);
closedir(DIR);
foreach $line (@contents){
	($name, $extension) = split (/\./, $line);
	if ($extension eq "lng"){
		$selected = "";
		if ($line eq $language) { $selected = " selected" }
		$yymain .= "    <option value=\"$line\"$selected>$name\n";
	}
}
$yymain .= qq~
</select></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'348'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="maintenance"$mainchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'348Text'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text size="45" name="maintenancetext" value="$maintenancetext"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'632'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="guestaccess"$guestaccchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'380'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_guestposting" $gpchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'432'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cookielength" size="5" value="$Cookie_Length"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'352'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cookieusername" size="20" value="$cookieusername"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'353'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cookiepassword" size="20" value="$cookiepassword"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'584'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="regagree"$agreechecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'702'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailpassword"$mailpasschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'639'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailnewpass"$newpasschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'619'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailwelcome"$welchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'354'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="mailprog" size="20" value="$mailprog"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'407'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="smtp_server" size="20" value="$smtp_server"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'355'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="webmaster_email" size="35" value="$webmaster_email"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'404'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="mailtype" size=1>
    <option value="0"$mts1>$txt{'405'}
    <option value="1"$mts2>$txt{'406'}
    <option value="2"$mts3>Net::SMTP
    </select></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'356'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="boarddir" size="30" value="$boarddir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'357'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="datadir" size="30" value="$datadir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'358'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="memberdir" size="30" value="$memberdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'359'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="boardsdir" size="30" value="$boardsdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'360'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="sourcedir" size="30" value="$sourcedir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'361'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="vardir" size="30" value="$vardir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'362'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="facesdir" size="30" value="$facesdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'25'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="soundsdir" size="30" value="$soundsdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'26'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="soundsurl" size="45" value="$soundsurl"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'423'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="facesurl" size="45" value="$facesurl"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$smi_txt{'2'}</font><br><font size="1">$smi_txt{'4'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="smiliesdir" size="30" value="$smiliesdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$smi_txt{'3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="smiliesurl" size="45" value="$smiliesurl"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'363'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="imagesdir" size="45" value="$imagesdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'41'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="barsdir" size="30" value="$barsdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'42'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="barsurl" size="45" value="$barsurl"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'390'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="faderpath" size="45" value="$faderpath"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'506'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ubbcjspath" size="45" value="$ubbcjspath"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'364'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="helpfile" size="45" value="$helpfile"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"><b><font size="1">$txt{'784'}</font></b></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'365'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="titlebg" size="10" value="$color{'titlebg'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'366'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="titletext" size="10" value="$color{'titletext'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'367'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="windowbg" size="10" value="$color{'windowbg'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'368'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="windowbg2" size="10" value="$color{'windowbg2'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'640'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="windowbg3" size="10" value="$color{'windowbg3'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'369'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="catbg" size="10" value="$color{'catbg'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'370'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="bordercolor" size="10" value="$color{'bordercolor'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'389'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="fadertext" size="10" value="$color{'fadertext'}"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'521'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="menutype"$menuchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'522'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="curposlinks"$cpchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'523'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="profilebutton"$pbchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'382'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showlatestmember" $slmchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'387'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="shownewsfader" $snfchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'388'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="fadertime" size="5" value="$fadertime"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'509'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showrecentbar" $srbarchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'618'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmarkread" $smreadchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'732'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showbdescrip" $bdescripchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'383'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmodify" $smodchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'384'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showuserpic" $supicchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'385'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showusertext" $sutextchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'386'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showgenderimage" $sgichecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'740'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showyabbcbutt" $syabbcchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'587'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="timeselect" size=1>
    <option value="1"$tsl1>$txt{'480'}
    <option value="5"$tsl5>$txt{'484'}
    <option value="4"$tsl4>$txt{'483'}
    <option value="2"$tsl2>$txt{'481'}
    <option value="3"$tsl3>$txt{'482'}
    <option value="6"$tsl6>$txt{'485'}
    </select>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'371'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeoffset" size="5" value="$timeoffset"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$smi_txt{'5'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="show_smilie_block" value="1"$showblockchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'378'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_ubbc"$ubbcchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'524'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="autolinkurls"$aluchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'379'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_news" $newschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'498'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxmesslen" size="5" value="$MaxMessLen"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'28'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="numpolloptions" size="5" value="$numpolloptions"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'61'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpq" size="5" value="$maxpq"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'62'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpo" size="5" value="$maxpo"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'63'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpc" size="5" value="$maxpc"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'29'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="useraddpoll"$uapchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'60'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="ubbcpolls"$upchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'746'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowpics" $allowpicschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification" $notifchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'723'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allow_hide_email" $ahmchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'689'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxsiglen" size="5" value="$MaxSigLen"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'408'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeout" size="5" value="$timeout"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'75'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numposts" size="5" value="$numposts"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'52'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=text name="imspam" size="5" value="$imspam" maxlength="2"></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'43'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_buddies" $enable_buddieschecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'30'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_mailsounds" $senablemailsounds></td>
 </tr><tr>~;
if($soundsdir && opendir(DIR, "$soundsdir")) {
		opendir(DIR, "$soundsdir") || fatal_error("$txt{'230'} ($soundsdir)!<BR>$imtxt{'27'}");
		@contents = readdir(DIR);
		closedir(DIR);
		$sounds = "";
		if ($sound eq "blank.wav" || $sound eq "") { $sounds = qq~<option value="blank.wav"$checked selected>$imtxt{'28'}\n~; }
		else { $sounds = qq~<option value="blank.wav"$checked>$imtxt{'28'}\n~; }
		foreach $line (sort @contents) {
			chomp($line);
			($name, $extension) = split (/\./, $line);
			$checked = "";
			if ($line eq "$sound") { $checked = ' selected'; }
				if($extension =~ /wav/i) {
				$sounds .= qq~<option value="$line"$checked>$name\n~;
				}
			}
$yymain .= qq~
<bgsound id="sound">
<script language="JavaScript1.2" type="text/javascript">
<!--
function playSound() { document.all.sound.src = "$soundsurl/"+document.all.sounds_on.options[document.all.sounds_on.selectedIndex].value; }
//-->
</script>	
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>$imtxt{'76'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="sounds_on" size="4" onChange="playSound()">$sounds</select>
</td></tr>
~;
} else {
$yymain .= qq~<script language="javascript"> alert("$imtxt{'77'}"); </script>~;
}
$yymain .= qq~
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'05'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_mailpopup" $senablemailpopup></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'44'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="popup_on" $popup_onchecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'06'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_imlimit" $senableimlimit></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'03'} $txt{'320'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numobox" size="5" value="$numobox"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'03'} $txt{'316'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numibox" size="5" value="$numibox"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'03'} $imtxt{'46'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numstore" size="5" value="$numstore"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'33'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="send_welcomeim" $send_welcomeimchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'86'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="system_im" $system_imchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'34'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type "text" name="sendname" size="35" value="$sendname"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'36'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><textarea name="imsubject" cols="35" rows="1">$imsubject</textarea></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'35'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><textarea name="imtext" cols="35" rows="4">$imtext</textarea></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'476'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_width" size="5" value="$userpic_width"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'477'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_height" size="5" value="$userpic_height"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'478'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_limits" size="45" value="$userpic_limits"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'588'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="jrmem" size="5" value="$JrPostNum"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'589'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="fullmem" size="5" value="$FullPostNum"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'590'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="srmem" size="5" value="$SrPostNum"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'591'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="godmem" size="5" value="$GodPostNum"></td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/guest.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>$membtxt{'13'}</b></font></td>
  </tr><tr>
    <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <table width="100%" border="0" cellspacing="0" cellpadding="4" align="left">
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'54'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'45'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'46'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'47'}</b></font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'56'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="view_gendcolm" $sviewgendcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="radio" name="gendcol" value="pic" $sgendpic> <img src="$imagesdir/gender.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="radio" name="gendcol" value="txt" $sgendtxt> <font size="2">$membtxt{'55'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'01'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mailcolm" $sviewmailcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="pic" $smailpic> <img src="$imagesdir/email.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="txt" $smailtxt> <font size="2">$membtxt{'48'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'07'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_wwwcolm" $sviewwwwcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="wwwcol" value="pic" $swwwpic> <img src="$imagesdir/www.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="wwwcol" value="txt" $swwwtxt> <font size="2">$membtxt{'49'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'44'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_imcolm" $sviewimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="imcol" value="pic" $simpic> <img src="$imagesdir/message.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="imcol" value="txt" $simtxt> <font size="2">$membtxt{'50'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'06'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_icqcolm" $sviewicqcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="icqcol" value="pic" $sicqpic> <img src="$imagesdir/icqflow.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="icqcol" value="txt" $sicqtxt> <font size="2">$membtxt{'51'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'17'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_yimcolm" $sviewyimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="yimcol" value="pic" $syimpic> <img src="$imagesdir/yim.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="yimcol" value="txt" $syimtxt> <font size="2">$membtxt{'52'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'18'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_aimcolm" $sviewaimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="aimcol" value="pic" $saimpic> <img src="$imagesdir/aim.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="aimcol" value="txt" $saimtxt> <font size="2">$membtxt{'53'}</font></td>
    </tr>
    ~;
    if(-e "$sourcedir/Msn.pl") {
    $yymain .= qq~
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'15'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_msncolm" $sviewmsncolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr>
    ~;
    }
    $yymain .= qq~
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'08'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_regdate" $sviewregcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'22'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_numbcolm" $sviewnumbcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'31'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_ipcolm" $sviewipcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'12'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="defaultml" size=1>
    <option value="0"$defml1>$membtxt{'09'}
    <option value="1"$defml2>$membtxt{'10'}
    <option value="2"$defml3>$membtxt{'14'}
    <option value="3"$defml4>$membtxt{'11'}
    </select>
    </td>
  </tr><tr>
    <td colspan="4" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'39'}:</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'02'} $membtxt{'02a'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	<input type=radio name="barmaxdepend" value="0" $bmd1> <font size="2">$membtxt{'03'} $membtxt{'05'}</font>
	<input type=radio name="barmaxdepend" value="1" $bmd2><input type=text name="barmaxnumb" size="5" value="$barmaxnumb"> <font size="2">$membtxt{'04'}</font>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'02'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="maxbar" size=1>
    <option value="$membtxt{'02b'}"$mxbar1>$membtxt{'02b'} $membtxt{'02e'}</option>
    <option value="$membtxt{'02c'}"$mxbar2>$membtxt{'02c'} $membtxt{'02e'}</option>
    <option value="$membtxt{'02d'}"$mxbar3>$membtxt{'02d'} $membtxt{'02e'}</option>
    </select>
    </td>
~;
	opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
	@contents = readdir(DIR);
	closedir(DIR);
	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $stfaultbar) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}
if(-e "$sourcedir/MemberGroups.pl") {
	$yymain .= qq~
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$MemStatNewbie</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	~;
}
else {
	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	chomp @membergroups;
	$yymain .= qq~
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[2]</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	~;
}
$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar() {
   document.images.icons.src="$barsurl/"+document.modsettings.defbar.options[document.modsettings.defbar.selectedIndex].value+".gif";
}
//-->
</script>
        <select name="defbar" onChange="showbar()">$bars</select>
        <img src="$barsurl/$stfaultbar.gif" name="icons" border=0 hspace=15>
    </td>

~;

	@defaultbar=();

if(-e "$sourcedir/MemberGroups.pl") {

	if (!-e "$vardir/barcolor.dat") {

		fopen(FILE, ">$vardir/barcolor.dat", 1);
		$i = 0;
		while($MemStat[$i]) {
			print FILE "CylBlue\n";
			$i++
		}
		fclose(FILE);
	}

	fopen(FILE, "$vardir/barcolor.dat");
	@defaultbar=<FILE>;
	fclose(FILE);
	chomp(@defaultbar);

	$taller = 0;

	while($MemStat[$taller]) {

		if($MemPostNum[$taller] ne 'x') {

			opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
			@contents = readdir(DIR);
			closedir(DIR);
			$bars = "";
			foreach $line (sort @contents){
				($name, $extension) = split (/\./, $line);
				$checked = "";
				if ($name eq $defaultbar[$taller]) { $checked = ' selected'; }
				if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
			}

			$yymain .= qq~

			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function showbar$taller() {
			   document.images.icons$taller.src="$barsurl/"+document.modsettings.barsel$taller.options[document.modsettings.barsel$taller.selectedIndex].value+".gif";
			}
			//-->
			</script>

		  </tr><tr>
		    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$MemStat[$taller]</font> <font size="1">($MemPostNum[$taller] $membtxt{'40'})</font></td>
		    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		        <select name="barsel$taller" onChange="showbar$taller()">$bars</select>
		        <img src="$barsurl/$defaultbar[$taller].gif" name="icons$taller" border=0 hspace=15>
		    </td>
			~;
		}
		$taller++;
	}
}
else {

	if (!-e "$vardir/barcolor.dat") {

		fopen(FILE, ">$vardir/barcolor.dat", 1);
		for($i=0;$i<4;$i++) {
			print FILE "CylBlue\n";
		}
		fclose(FILE);
	}

	fopen(FILE, "$vardir/barcolor.dat");
	@defaultbar=<FILE>;
	fclose(FILE);
	chomp(@defaultbar);

	opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
	@contents = readdir(DIR);
	closedir(DIR);

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[0]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar1() {
   document.images.icons1.src="$barsurl/"+document.modsettings.defbar1.options[document.modsettings.defbar1.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[3]</font> <font size="1">($JrPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar1" onChange="showbar1()">$bars</select>
		<img src="$barsurl/$defaultbar[0].gif" name="icons1" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[1]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar2() {
   document.images.icons2.src="$barsurl/"+document.modsettings.defbar2.options[document.modsettings.defbar2.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[4]</font> <font size="1">($FullPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar2" onChange="showbar2()">$bars</select>
		<img src="$barsurl/$defaultbar[1].gif" name="icons2" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[2]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar3() {
   document.images.icons3.src="$barsurl/"+document.modsettings.defbar3.options[document.modsettings.defbar3.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[5]</font> <font size="1">($SrPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar3" onChange="showbar3()">$bars</select>
		<img src="$barsurl/$defaultbar[2].gif" name="icons3" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[3]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar4() {
   document.images.icons4.src="$barsurl/"+document.modsettings.defbar4.options[document.modsettings.defbar4.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[6]</font> <font size="1">($GodPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar4" onChange="showbar4()">$bars</select>
		<img src="$barsurl/$defaultbar[3].gif" name="icons4" border=0 hspace=15>
    </td>

~;

}

$yymain .= qq~
  </tr><tr>
    <td colspan="4" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'37'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="guest_allow" $sguest_allow></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'38'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_numb" $sviewnumb></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$budtxt{'11'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_buddylist" $senablebuddy></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'373'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="MembersPerPage" size="5" value="$MembersPerPage"></td>
    </tr>
    </table></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>$yams_ver</I></b> &nbsp;</font><a href=http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl?board=;action=pgratinglink;editmode=new;itemlink=1050346688 target=_blank><img src="http://www.cd-profil.dk/yabb/yams13ver.gif" border="0" align="absmiddle"><br></a></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'374'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxdisplay" size="5" value="$maxdisplay"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'375'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxmessagedisplay" size="5" value="$maxmessagedisplay"></td>
 </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'690'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="clicklogtime" size="5" value="$ClickLogTime"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'376'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="max_log_days_old" size="5" value="$max_log_days_old"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  $attachment_status
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="upload_dir" size="35" value="$upload_dir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="http_dir" size="35" value="$http_dir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'47'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="servertype" size=1>
    <option value="0"$st0>Standard
    <option value="1"$st1>Unix/Linux
    <option value="2"$st2>Windows
    </select>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">Temp File Permission Settings</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="tempaccess" size=1>
    <option value="0"$tmpax0>Standard
    <option value="1"$tmpax1>User Override
    </select>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="limit" size="5" value="$limit"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="dirlimit" size="5" value="$dirlimit"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'14'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="extensions" size="35" value="$extlist"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'15'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="checkext" value="1"$checkextcheck></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'16'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="amdisplaypics" value="1"$amdisplaypicscheck></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'17'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowattach" value="1"$allowattachcheck></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'18'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowguestattach" value="1"$allowguestattachcheck></td>
  </tr><tr><!-- AMOD -->
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" color="$color{'windowbg3'}" class="windowbg3"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'392'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_EX" size="5" value="$LOCK_EX"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'393'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_UN" size="5" value="$LOCK_UN"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'607'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_SH" size="5" value="$LOCK_SH"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'391'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="use_flock" size=1>
    <option value="0"$fls1>$txt{'401'}
    <option value="1"$fls2>$txt{'402'}
    <option value="2"$fls3>$txt{'403'}
    </select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'615'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="usetempfile"$utfchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'630'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="faketruncation"$truncchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center" valign="middle">
    <BR><input type=submit value="$txt{'10'}">
    </td>
  </tr>
</table>
</td>
</tr>
</table>
</form>
~;
	$yytitle = $txt{'222'};
	&template;
	exit;
}

sub GetBoardURL {
	my $url = 'http://' . ($ENV{'HTTP_HOST'} ? $ENV{'HTTP_HOST'} : $ENV{'SERVER_NAME'}) .
	($ENV{'SERVER_PORT'} != 80 ? ":$ENV{'SERVER_PORT'}" : '') .
	$ENV{'SCRIPT_NAME'};
	$url =~ s~/[^/]+\Z~/~;
	return $url;
}

# Gets our current absolute path. Needed for error messages.
sub GetDirPath {
	eval 'use Cwd; $cwd = cwd();';
	unless( $cwd ) { $cwd = `pwd`; chomp $cwd; }
	unless($cwd) { $cwd = $0 || $ENV{'PWD'} || $ENV{'CWD'} || ( $ENV{'DOCUMENT_ROOT'} . '/' . $ENV{'SCRIPT_NAME'} || $ENV{'PATH_INFO'} ); }
	$cwd =~ tr~\\~/~;
	$cwd =~ s~\A(.+)/\Z~$1~;
	$cwd =~ s~\A(.+)/YaBB\.\w+\Z~$1~i;
	return $cwd;
}

sub is_exe {
    my ($cmd,$name);
    foreach $cmd (@_) {
	$name = ($cmd =~ /^(\S+)/)[0];	# remove any options
	return ($cmd) if (-x $name and ! -d $name and $name =~ m:/:);	# check for absolute or relative path
	if (defined $ENV{PATH}) {
	    my $dir;
	    foreach $dir (split(/:/, $ENV{PATH})) {
		return "$dir/$cmd" if (-x "$dir/$name" && ! -d "$dir/$name");
	    }
	}
    }
    0;
}

sub ModifySettings2 {
	&is_admin;

	my @onoff = qw/
		allowpics showyabbcbutt showbdescrip maintenance guestaccess insert_original enable_ubbc enable_news enable_guestposting enable_notification showlatestmember showrecentbar showmarkread showmodify showuserpic showusertext showgenderimage shownewsfader MenuType curposlinks profilebutton autolinkurls emailpassword RegAgree emailwelcome allow_hide_email usetempfile faketruncation emailnewpass/;
	push(@onoff, "useraddpoll", "ubbcpolls", "pollcomments");

	push(@onoff, "enable_mailsounds", "enable_mailpopup", "enable_imlimit", "numibox", "numobox", "send_welcomeim", "enable_buddies", "enable_rim", "numposts", "popup_on", "system_im");
	push(@onoff, "view_mailcolm", "view_wwwcolm", "view_imcolm", "view_icqcolm", "view_yimcolm", "view_aimcolm", "view_msncolm", "view_regdate", "barmaxdepend", "defaultml");
	push(@onoff, "view_numbcolm", "view_ipcolm", "guest_allow", "view_numb", "defbar", "mailcol", "wwwcol", "imcol", "icqcol", "yimcol", "aimcol");
	push(@onoff, "view_gendcolm", "gendcol", "barmaxnumb", "maxbar", "enable_buddylist");
	# Set as 0 or 1 if box was checked or not
	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;
	$guestaccess = $guestaccess ? 0 : 1;
fopen( FILE, ">$vardir/barcolor.dat", 1);
if(-e "$sourcedir/MemberGroups.pl") {
	$taller = 0;
	while($MemStat[$taller]) {
		if($MemPostNum[$taller] ne 'x') {
			$defaultbar[$taller] = $FORM{"barsel$taller"} || 'CylBlue';
			print FILE "$defaultbar[$taller]\n";
		}
		else { print FILE "CylBlue\n"; }
		$taller++
	}
}
else {
	$defaultbar[0] = $FORM{"defbar1"} || 'CylBlue';
	$defaultbar[1] = $FORM{"defbar2"} || 'CylBlue';
	$defaultbar[2] = $FORM{"defbar3"} || 'CylBlue';
	$defaultbar[3] = $FORM{"defbar4"} || 'CylBlue';
	print FILE "$defaultbar[0]\n";
	print FILE "$defaultbar[1]\n";
	print FILE "$defaultbar[2]\n";
	print FILE "$defaultbar[3]\n";
}
fclose(FILE);

	# If empty fields are submitted, set them to default-values to save yabb from crashing
	$upload_dir = $FORM{'upload_dir'};
	$upload_dir =~ s~\s+$~~;
	$http_dir = $FORM{'http_dir'};
	$http_dir =~ s~\s+$~~;
	$servertype = $FORM{'servertype'} || 0;
	$tempaccess = $FORM{'tempaccess'} || 0;
	$extensions = $FORM{'extensions'};
	$extensions =~ s~\s+$~~;
	$limit = $FORM{'limit'} || 0;
	$dirlimit = $FORM{'dirlimit'} || 0;
	$checkext = $FORM{'checkext'} || 0;
	$amdisplaypics = $FORM{'amdisplaypics'} || 0;
	$allowattach = $FORM{'allowattach'} || 0;
	$allowguestattach = $FORM{'allowguestattach'} || 0;
	$maintenancetext = $FORM{'maintenancetext'} || "";
	&ToHTML($maintenancetext);
	$timeout = $FORM{'timeout'} || 5;
	$fadertime = $FORM{'fadertime'} || 5000;
	$timeselected = $FORM{'timeselect'} || 0;
	$gendcol = $FORM{'gendcol'} || 'pic';
	$mailcol = $FORM{'mailcol'} || 'pic';
	$wwwcol = $FORM{'wwwcol'} || 'pic';
	$imcol = $FORM{'imcol'} || 'pic';
	$icqcol = $FORM{'icqcol'} || 'pic';
	$yimcol = $FORM{'yimcol'} || 'pic';
	$aimcol = $FORM{'aimcol'} || 'pic';
	$barmaxdepend = $FORM{'barmaxdepend'} || 0;
	if ($FORM{'maxbar'} =~ /\d+/)  { $maxbar  = $FORM{'maxbar'};  } else { $maxbar = 100; }
	if ($FORM{'barmaxnumb'} =~ /\d+/)  { $barmaxnumb  = $FORM{'barmaxnumb'};  } else { $barmaxnumb = 500; }
	$defaultml = $FORM{'defaultml'} || 0;
	$stfaultbar = $FORM{'defbar'} || 'CylBlue';
	$timeoffset = $FORM{'timeoffset'} || 0;
	$TopAmmount = $FORM{'TopAmmount'} || 25;
	$MembersPerPage = $FORM{'MembersPerPage'} || 20;
	$maxdisplay = $FORM{'maxdisplay'} || 20;
	$maxmessagedisplay = $FORM{'maxmessagedisplay'} || 20;
	$max_log_days_old = $FORM{'max_log_days_old'} || 21;
	$clicklogtime = $FORM{'clicklogtime'} || 1440;
	if($clicklogtime >= 1440) { $clicklogtime = 1439; }
	$use_flock = $FORM{'use_flock'} || 0;
	$LOCK_EX = $FORM{'LOCK_EX'} || 2;
	$LOCK_UN = $FORM{'LOCK_UN'} || 8;
	$LOCK_SH = $FORM{'LOCK_SH'} || 1;
	$Cookie_Length = $FORM{'cookielength'} || 60;
	$cookieusername = $FORM{'cookieusername'} || 'YaBBusername';
	$cookiepassword = $FORM{'cookiepassword'} || 'YaBBpassword';
	if ($cookieusername eq $cookiepassword) {$cookieusername = 'YaBBusername'; $cookiepassword = 'YaBBpassword';}
	$maxmesslen = $FORM{'maxmesslen'} || 5000;
	$numpolloptions = $FORM{'numpolloptions'} || 8;
	$maxpq = $FORM{'maxpq'} || 60;
	$maxpo = $FORM{'maxpo'} || 50;
	$maxpc = $FORM{'maxpc'} || 0;
	$maxsiglen = $FORM{'maxsiglen'} || 200;
	$jrmem = $FORM{'jrmem'} || 50;
	$fullmem = $FORM{'fullmem'} || 100;
	$srmem = $FORM{'srmem'} || 250;
	$godmem = $FORM{'godmem'} || 500;
	$language = $FORM{'language'} || 'english.lng';
	$mbname = $FORM{'mbname'} || 'My YaBB 1 Gold - SP1';
	$mbname =~ s/\"/\'/g;
	$boardurl = $FORM{'boardurl'} || &GetBoardURL;
	$boarddir = $FORM{'boarddir'} || &GetDirPath;
	$boardsdir = $FORM{'boardsdir'} || "$boarddir/Boards";
	$datadir = $FORM{'datadir'} || "$boarddir/Messages";
	$memberdir = $FORM{'memberdir'} || "$boarddir/Members";
	$sourcedir = $FORM{'sourcedir'} || "$boarddir/Sources";
	$vardir = $FORM{'vardir'} || "$boarddir/Variables";
	$facesdir = $FORM{'facesdir'} || "$boarddir/YaBBImages/avatars";
	$facesurl = $FORM{'facesurl'} || "$boardurl/YaBBImages/avatars";
	$soundsdir = $FORM{'soundsdir'} || "$boarddir/sounds";
	$soundsurl = $FORM{'soundsurl'} || "$boardurl/sounds";
	$numposts = $FORM{'numposts'} || 0;
	$sounds_on = $FORM{'sounds_on'} || "blank.wav";
	$numibox = $FORM{'numibox'} || 20;
	$numobox = $FORM{'numobox'} || 20;
	$numstore = $FORM{'numstore'} || 20;
	$sendname = $FORM{'sendname'} || System;
	$imspam = $FORM{'imspam'} || off;
	$FORM{'imtext'} =~ s~\n~\&\&~g;
	$imtext = $FORM{'imtext'} || "Welcome in our community";
		$imtext =~ s~\A\s+~~;
		$imtext =~ s~\s+\Z~~;
		$imtext =~ s~[\n\r]~~g;
		$imtext =~ s~"~\\"~g;
		$imtext =~ s~@~\\@~g;
	$imsubject = $FORM{'imsubject'} || "Welcome to $mbname";
		$imsubject =~ s~"~\\"~g;
		$imsubject =~ s~[\n\r]~~g;
		$imsubject =~ s~\<BR\>~~gi;
		$imsubject =~ s~\A\s+~~;
		$imsubject =~ s~\s+\Z~~;
	$smiliesdir = $FORM{'smiliesdir'} || "";
	$smiliesurl = $FORM{'smiliesurl'} || "$boardurl/YaBBImages/smilies";
	$show_smilie_block = $FORM{'show_smilie_block'} || 0;
	$imagesdir = $FORM{'imagesdir'} || "$boardurl/YaBBImages";
	$barsdir = $FORM{'barsdir'} || "../../YaMSbars";
	$barsurl = $FORM{'barsurl'} || "$boardurl/YaMSbars";
	$helpfile = $FORM{'helpfile'} || "$boardurl/YaBBHelp/index.html";
	$mailprog = $FORM{'mailprog'} || &is_exe('/usr/lib/sendmail','/usr/sbin/sendmail','/usr/ucblib/sendmail','sendmail','mailx','Mail','mail');
	$smtp_server = $FORM{'smtp_server'} || '127.0.0.1';
	$webmaster_email = $FORM{'webmaster_email'} || 'webmaster@mysite.com';
	$mailtype = $FORM{'mailtype'} || 0;
	$color{'titlebg'} = $FORM{'titlebg'} || '#6E94B7';
	$color{'titletext'} = $FORM{'titletext'} || '#FFFFFF';
	$color{'windowbg'} = $FORM{'windowbg'} || '#AFC6DB';
	$color{'windowbg2'} = $FORM{'windowbg2'} || '#F8F8F8';
	$color{'windowbg3'} = $FORM{'windowbg3'} || '#6394BD';
	$color{'catbg'} = $FORM{'catbg'} || '#DEE7EF';
	$color{'bordercolor'} = $FORM{'bordercolor'} || '#6394BD';
	$color{'fadertext'} = $FORM{'fadertext'} || '#D4AD00';
	$faderpath = $FORM{'faderpath'} || "$boardurl/fader.js";
	$ubbcjspath = $FORM{'ubbcjspath'} || "$boardurl/ubbc.js";
	if ($FORM{'userpic_width'} =~ /\d+/)  { $userpic_width  = $FORM{'userpic_width'};  }
	else { $userpic_width = 65; }
	if ($FORM{'userpic_height'} =~ /\d+/) {	$userpic_height = $FORM{'userpic_height'}; }
	else { $userpic_height = 65; }
	$userpic_limits = $FORM{'userpic_limits'} || 'Please note that your image has to be <b>gif</b> or <b>jpg</b> and that it will be resized!';
	$userpic_limits =~ s/\"/\'/g;

	my $filler = q~                                                                               ~;
	my $setfile = << "EOF";
###############################################################################
# Settings.pl                                                                 #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3.1                                      #
# Released:       December 2001; Updated April 18, 2003                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

########## Board Info ##########
# Note: these settings must be properly changed for YaBB to work

\$maintenance = $maintenance;				# Set to 1 to enable Maintenance mode
\$guestaccess = $guestaccess;				# Set to 0 to disallow guests from doing anything but login or register

\$language = "$language";				# Change to language pack you wish to use
\$mbname = q^$mbname^;					# The name of your YaBB forum
\$boardurl = "$boardurl";				# URL of your board's folder (without trailing '/')

\$Cookie_Length = $Cookie_Length;			# Default minutes to set login cookies to stay for
\$cookieusername = "$cookieusername";			# Name of the username cookie
\$cookiepassword = "$cookiepassword";			# Name of the password cookie

\$RegAgree = $RegAgree;					# Set to 1 to display the registration agreement when registering
\$emailpassword = $emailpassword;			# 0 - instant registration. 1 - password emailed to new members
\$emailnewpass = $emailnewpass;				# Set to 1 to email a new password to members if they change their email address
\$emailwelcome = $emailwelcome;				# Set to 1 to email a welcome message to users even when you have mail password turned off

\$mailprog = "$mailprog";				# Location of your sendmail program
\$smtp_server = "$smtp_server";				# Address of your SMTP-Server
\$webmaster_email = q^$webmaster_email^;		# Your email address. (eg: \$webmaster_email = q^admin\@host.com^;)
\$mailtype = $mailtype;					# Mail program to use: 0 = sendmail, 1 = SMTP, 2 = Net::SMTP


########## Directories/Files ##########
# Note: directories other than \$imagesdir do not have to be changed unless you move things

\$boarddir = "$boarddir"; 				# The server path to the board's folder (usually can be left as '.')
\$boardsdir = "$boardsdir";         			# Directory with board data files
\$datadir = "$datadir";         			# Directory with messages
\$memberdir = "$memberdir";        			# Directory with member files
\$sourcedir = "$sourcedir";        			# Directory with YaBB source files
\$vardir = "$vardir";         				# Directory with variable files
\$facesdir = "$facesdir";				# The server path to your avatars (userpics) folder
\$facesurl = "$facesurl";				# URL to your avatars folder
\$soundsdir = "$soundsdir";				# Absolute Path to your sounds folder
\$soundsurl = "$soundsurl";				# URL to your sounds folder

\$smiliesdir = "$smiliesdir";				# The server path to your smilies folder
\$smiliesurl = "$smiliesurl";				# URL to your smilies folder
\$imagesdir = "$imagesdir";				# URL to your images folder
\$barsdir = "$barsdir";					# Absolute Path to your YaMS bars folder
\$barsurl = "$barsurl";					# URL to your YaMS bars folder
\$ubbcjspath = "$ubbcjspath";	                        # URL to your 'ubbc.js' (REQUIRED for post/modify to work properly)
\$faderpath = "$faderpath";				# URL to your 'fader.js'
\$helpfile = "$helpfile";				# URL to your help file


########## Colors ##########
# Note: equivalent to colors in CSS tag of template.html, so set to same colors preferrably
# for browsers without CSS compatibility and for some items that don't use the CSS tag

\$color{'titlebg'} = "$color{'titlebg'}";		# Background color of the 'title-bar'
\$color{'titletext'} = "$color{'titletext'}";		# Color of text in the 'title-bar' (above each 'window')
\$color{'windowbg'} = "$color{'windowbg'}";		# Background color for messages/forms etc.
\$color{'windowbg2'} = "$color{'windowbg2'}";		# Background color for messages/forms etc.
\$color{'windowbg3'} = "$color{'windowbg3'}";		# Color of horizontal rules in posts
\$color{'catbg'} = "$color{'catbg'}";			# Background color for category (at Board Index)
\$color{'bordercolor'} = "$color{'bordercolor'}";	# Table Border color for some tables
\$color{'fadertext'}  = "$color{'fadertext'}";		# Color of text in the NewsFader (news color)

########## Layout ##########

\$maintenancetext = "$maintenancetext";			# User-defined text for Maintenance mode (leave blank for default text)
\$MenuType = $MenuType;					# 1 for text menu or anything else for images menu
\$curposlinks = $curposlinks;				# 1 for links in navigation on current page, or 0 for text without link
\$profilebutton = $profilebutton;			# 1 to show view profile button under post, or 0 for blank
\$timeselected = $timeselected;				# Select your preferred output Format of Time and Date
\$allow_hide_email = $allow_hide_email;			# Allow users to hide their email from public. Set 0 to disable
\$view_gendcolm = $view_gendcolm;				# Set to 0 to hide Gender column in Memberlist
\$view_mailcolm = $view_mailcolm;	     			# Set to 0 to hide e-mail column in Memberlist
\$view_wwwcolm = $view_wwwcolm;	     			# Set to 0 to hide WWW column in Memberlist
\$view_imcolm = $view_imcolm;	   	  			# Set to 0 to hide IM column in Memberlist
\$view_icqcolm = $view_icqcolm;	     			# Set to 0 to hide ICQ column in Memberlist
\$view_yimcolm = $view_yimcolm;	     			# Set to 0 to hide YIM column in Memberlist
\$view_aimcolm = $view_aimcolm;	     			# Set to 0 to hide AIM column in Memberlist
\$gendcol = $gendcol;						# Set to txt for text in Gender column
\$mailcol = $mailcol;						# Set to txt for text in e-mail column
\$wwwcol = $wwwcol;						# Set to txt for text in WWW column
\$imcol = $imcol;							# Set to txt for text in IM column
\$icqcol = $icqcol;						# Set to txt for text in ICQ column
\$yimcol = $yimcol;						# Set to txt for text in YIM column
\$aimcol = $aimcol;						# Set to txt for text in AIM column
if(-e "$sourcedir/Msn.pl") {
	\$view_msncolm = $view_msncolm;	     		# Set to 0 to hide MSN column in Memberlist
}
\$view_regdate = $view_regdate;	     			# Set to 0 to hide registration-date column in Memberlist
\$view_numbcolm = $view_numbcolm;	     			# Set to 0 to hide member number column in Memberlist
\$view_ipcolm = $view_ipcolm;	     				# Set to 0 to hide IP number column in Memberlist
\$guest_allow = $guest_allow;	     				# Set to 0 to disallow guests to view Memberlist
\$view_numb = $view_numb;		     			# Set to 0 to hide member number in posts and profile
\$barmaxdepend = $barmaxdepend;				# Set to 0 to let bar-max-length depend on top poster or 1 to depend on a number of your choise
\$barmaxnumb = $barmaxnumb;					# Select number of post for max. bar-length in memberlist
\$maxbar = $maxbar;
\$defaultml = $defaultml;					# Select default sort-column
\$stfaultbar = $stfaultbar;					# Select Standard Bar-color in memberlist
\$enable_buddylist = $enable_buddylist;  			# Set to 0 to disable buddylist
\$showlatestmember = $showlatestmember;			# Set to 1 to display "Welcome Newest Member" on the Board Index
\$shownewsfader = $shownewsfader;			# 1 to allow or 0 to disallow NewsFader javascript on the Board Index
							# If 0, you'll have no news at all unless you put <yabb news> tag
							# back into template.html!!!
\$Show_RecentBar = $showrecentbar;			# Set to 1 to display the Recent Post on Board Index
\$showmarkread = $showmarkread;				# Set to 1 to display and enable the mark as read buttons
\$showmodify = $showmodify;				# Set to 1 to display "Last modified: Realname - Date" under each message
\$ShowBDescrip = $showbdescrip;				# Set to 1 to display board descriptions on the topic (message) index for each board
\$showuserpic = $showuserpic;				# Set to 1 to display each member's picture in the message view (by the ICQ.. etc.)
\$showusertext = $showusertext;				# Set to 1 to display each member's personal text in the message view (by the ICQ.. etc.)
\$showgenderimage = $showgenderimage;			# Set to 1 to display each member's gender in the message view (by the ICQ.. etc.)
\$showyabbcbutt = $showyabbcbutt;                       # Set to 1 to display the yabbc buttons on Posting and IM Send Pages
\$enable_buddies = $enable_buddies;			# Set to 1 to enable the BuddyList for users
\$enable_mailsounds = $enable_mailsounds;		# Set to 1 to enable info-sounds on new private messages
\$sound = \"$sounds_on\";				# Set to 1 to enable Sound as default for new regged users
\$enable_mailpopup = $enable_mailpopup;			# Set to 1 to enable info-popup on new private messages
\$popup_on = $popup_on;					# Set to 1 to enable Popups as default for new regged users
\$enable_imlimit = $enable_imlimit;			# Set to 1 to enable limitation of incoming and outgoing im messages

########## Automated IM Settings ##########

\$imtext = qq~$imtext~;
\$sendname = qq~$sendname~;
\$imsubject = "$imsubject";
\$send_welcomeim = $send_welcomeim;			# Set to 1 to enable welcome im's
\$system_im = $system_im;				# Set to 1 to disable answering of welcome im's

########## File Attachment Settings ##########

\$limit = $limit;  					# Set to the maximum number of kilobytes an attachment can be. Set to 0 to disable the file size check.
\$dirlimit = $dirlimit;  				# Set to the maximum number of kilobytes the attachment directory can hold. Set to 0 to disable the directory size check.
\$upload_dir = '$upload_dir';  				# The absolute path to the directory where your attachments are to be stored (without trailing '/' )
\$tempaccess = $tempaccess;
if (\$tempaccess == 1) {
\$TempFile::TMPDIRECTORY = '$upload_dir';		# Puts temporary files used into same folder as attachments to prevent permission problems
}
\$http_dir = '$http_dir';  				# The full url to the directory where your attachments are to be stored (without trailing '/' )
\$servertype = $servertype;				# Set to 0 for Standard cross-platform uploading. If you experience problems, set to 1 if you are running your YaBB on a Unix/Linux webhost, set to 2 if you are running on Windows.
\@ext = qw($extensions);  				# The allowed file extensions for file attachements. Variable should be set in the form of "jpg bmp gif" and so on.
\$checkext = $checkext;  				# Set to 1 to enable file extension checking, set to 0 to allow all file types to be uploaded
\$amdisplaypics = $amdisplaypics;  			# Set to 1 to display attached pictures in posts, set to 0 to only show a link to them.
\$allowattach = $allowattach;				# Set to 1 to allow file attaching, set to 0 to disable file attaching.
\$allowguestattach = $allowguestattach;			# Set to 1 to allow guests to upload attachments, 0 to disable guest attachment uploading.

########## Feature Settings ##########

\$show_smilie_block = $show_smilie_block;		# Set to 1 if you want to display the smiley block
\$enable_ubbc = $enable_ubbc;				# Set to 1 if you want to enable UBBC (Uniform Bulletin Board Code)
\$enable_news = $enable_news;				# Set to 1 to turn news on, or 0 to set news off
\$allowpics = $allowpics;				# set to 1 to allow members to choose avatars in their profile
\$enable_guestposting = $enable_guestposting;		# Set to 0 if do not allow 1 is allow.
\$enable_notification = $enable_notification;		# Allow e-mail notification
\$autolinkurls = $autolinkurls;				# Set to 1 to turn URLs into links, or 0 for no auto-linking.

\$timeoffset = $timeoffset;				# Time Offset (so if your server is EST, this would be set to -1 for CST)
\$TopAmmount = $TopAmmount;				# No. of top posters to display on the top members list
\$MembersPerPage = $MembersPerPage;			# No. of members to display per page of Members List - All
\$maxdisplay = $maxdisplay;				# Maximum of topics to display
\$maxmessagedisplay = $maxmessagedisplay;		# Maximum of messages to display
\$MaxMessLen = $maxmesslen;  				# Maximum Allowed Characters in a Posts
\$numpolloptions = $numpolloptions;  			# Number of poll options
\$maxpq = $maxpq;  						# Maximum Allowed Characters in a Poll Qestion?
\$maxpo = $maxpo;  						# Maximum Allowed Characters in a Poll Option?
\$maxpc = $maxpc;  						# Maximum Allowed Characters in a Poll Comment?
\$useraddpoll = $useraddpoll;  				# Allow users to add polls to existing threads? (1 = yes)
\$ubbcpolls = $ubbcpolls;  					# Allow UBBC tags and smilies in polls? (1 = yes)

\$MaxSigLen = $maxsiglen;				# Maximum Allowed Characters in Signatures
\$ClickLogTime = $clicklogtime;				# Time in minutes to log every click to your forum (longer time means larger log file size)
\$max_log_days_old = $max_log_days_old;			# If an entry in the user's log is older than ... days remove it
							# Set to 0 if you want it disabled
\$fadertime = $fadertime;				# Length in milliseconds to delay between each item in the news fader
\$timeout = $timeout;					# Minimum time between 2 postings from the same IP
\$numposts = $numposts;					# Number of posts required to send Instant Messages
\$imspam = $imspam;					# Percent of Users a user is a allowed to send a message at once
\$numibox = $numibox;					# Number of maximum Messages in the IM-Inbox
\$numobox = $numobox;					# Number of maximum Messages in the IM-Outbox
\$numstore = $numstore;					# Number of maximum Messages in the Storage box


########## Membergroups ##########

\$JrPostNum = $jrmem;					# Number of Posts required to show person as 'junior' membergroup
\$FullPostNum = $fullmem;				# Number of Posts required to show person as 'full' membergroup
\$SrPostNum = $srmem;					# Number of Posts required to show person as 'senior' membergroup
\$GodPostNum = $godmem;					# Number of Posts required to show person as 'god' membergroup


########## MemberPic Settings ##########

\$userpic_width = $userpic_width;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$userpic_height = $userpic_height;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$userpic_limits = qq~$userpic_limits~;			# Text To Describe The Limits


########## File Locking ##########

\$LOCK_EX = $LOCK_EX;					# You can probably keep this as it is set now.
\$LOCK_UN = $LOCK_UN;					# You can probably keep this as it is set now.
\$LOCK_SH = $LOCK_SH;					# You can probably keep this as it is set now.

\$use_flock = $use_flock;				# Set to 0 if your server doesn't support file locking,
							# 1 for Unix/Linux and WinNT, and 2 for Windows 95/98/ME

\$usetempfile = $usetempfile;				# Write to a temporary file when updating large files.
							# This can potentially save your board index files from
							# being corrupted if a process aborts unexpectedly.
							# 0 to disable, 1 to enable.

\$faketruncation = $faketruncation;			# Enable this option only if YaBB fails with the error:
							# "truncate() function not supported on this platform."
							# 0 to disable, 1 to enable.

1;
EOF

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(FILE, ">$boarddir/Settings.pl");
	print FILE $setfile;
	fclose(FILE);

	$password = crypt($settings[0],$pwseed);
	$Cookie_Exp_Date = 'Sunday, 17-Jan-2038 00:00:00 GMT';
	$yySetCookies1 = cookie(-name    =>   "$cookieusername",
				-value   =>   "$username",
				-path    =>   "/",
				-expires =>   "$Cookie_Exp_Date");
	$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
				-value   =>   "$password",
				-path    =>   "/",
				-expires =>   "$Cookie_Exp_Date");
	&LoadIMs;
	&LoadUserSettings;
	&WriteLog;
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

1;